﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace LegoPixelSpaceInvaders
{
    public partial class Form1 : Form, IDrawingContext, IAudioContext
    {
        [DllImport("Kernel32.dll")]
        static extern bool Beep(
            uint dwFreq, uint dwDuration
        );

        [DllImport("user32.dll")]
        static extern short GetAsyncKeyState(System.Windows.Forms.Keys vKey);

        private Bitmap m_Bitmap;
        private int m_Index;
        private static Random m_Rnd = new Random();
        private Player m_Player;
        private Mci m_Krach;
        
        public Form1()
        {
            InitializeComponent();

            using (StreamWriter log = new StreamWriter(@"sound\sound.txt", false)) { }

            m_Bitmap = new Bitmap(113, 64);
            m_Krach = new Mci();
            m_Index = 0;
            m_Player = new Player(new Point(50, 54), new Swarm(new Point(2, 0)));
        }

        public void DrawPixel(int x, int y, System.Drawing.Color color)
        {
            if (x >= 0 && x < m_Bitmap.Width && y >= 0 && y < m_Bitmap.Height)
                m_Bitmap.SetPixel(x, y, color);
        }

        public void PlaySound(string name, int ballance)
        {
            string path = @"sound\" + name + ".wav";

            m_Krach.Open(path, name);
            m_Krach.setBalance(name, ballance * 5 + 500);
            m_Krach.Play(name, false);

            using(StreamWriter log = new StreamWriter(@"sound\sound.txt", true))
                log.WriteLine(m_Index.ToString() + ";" + path + ";" + ballance.ToString());
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            e.Graphics.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
            e.Graphics.DrawImage(m_Bitmap, new Rectangle(0, 0, Width + 6, Height + 6));
        }

        private void clearBitmap(System.Drawing.Color color)
        {
            for (int y = 0; y < m_Bitmap.Height; y++)
            {
                for (int x = 0; x < m_Bitmap.Width; x++)
                    DrawPixel(x, y, color);
            }
        }

        private void save()
        {
            m_Bitmap.Save(@"image\frame-" + m_Index.ToString("D4") + ".png", ImageFormat.Png);
            m_Index++;
        }

        private void timer_Tick(object sender, EventArgs e)
        {
            clearBitmap(System.Drawing.Color.Black);

            if (GetAsyncKeyState(Keys.Escape) < 0)
            {
                m_Krach.Close();
                this.Close();
            }

            m_Player.Update(this);
            
            m_Player.Draw(this);
            Invalidate();
            Application.DoEvents();
            save();
        }
    }
}
