﻿using System.Drawing;
using System.Collections.Generic;

namespace LegoPixelSpaceInvaders
{
    public class PacMan
    {
        private Point m_Position;
        private int m_Delay;
        private int m_State;
        private List<List<Point>> m_Sheet;

        public Point Position
        {
            get
            {
                return m_Position;
            }
            set
            {
                m_Position = value;
            }
        }

        public PacMan()
        {
            m_Sheet = new List<List<Point>>(16);

            for (int i = 0; i < 16; i++)
            {
                Bitmap bmp = new Bitmap(@"sheet\pacman" + i + ".png");
                m_Sheet.Add(new List<Point>());

                for (int y = 0; y < bmp.Height; y++)
                {
                    for (int x = 0; x < bmp.Width; x++)
                    {
                        if (bmp.GetPixel(x, y) == Color.FromArgb(255,255,0))
                            m_Sheet[i].Add(new Point(x, y));
                    }
                }
            }

            m_State = 7;
        }

        public void Update(IAudioContext context)
        {
            if (m_Delay < 7)
                m_Delay++;
            else
            {
                if (m_State < 15)
                    m_State++;
                else
                    m_State = 0;
            }
        }

        public void Draw(IDrawingContext context)
        {
            Color color = Color.Yellow;

            if (m_Delay < 7)
            {
                context.DrawPixel(m_Position.X, m_Position.Y, color);

                if (m_Delay > 0)
                {
                    context.DrawPixel(m_Position.X, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 1, color);
                }

                if (m_Delay > 1)
                {
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 2, color);
                }

                if (m_Delay > 2)
                {
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 3, color);
                }

                if (m_Delay > 3)
                {
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 4, color);
                }

                if (m_Delay > 4)
                {
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 5, color);
                }

                if (m_Delay > 5)
                {
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 6, color);
                }

                if (m_Delay > 6)
                {
                    context.DrawPixel(m_Position.X - 2, m_Position.Y - 7, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y - 7, color);
                    context.DrawPixel(m_Position.X, m_Position.Y - 7, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y - 7, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y - 7, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 6, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y - 5, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y - 4, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y - 3, color);
                    context.DrawPixel(m_Position.X - 7, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X + 7, m_Position.Y - 2, color);
                    context.DrawPixel(m_Position.X - 7, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X + 7, m_Position.Y - 1, color);
                    context.DrawPixel(m_Position.X - 7, m_Position.Y, color);
                    context.DrawPixel(m_Position.X + 7, m_Position.Y, color);
                    context.DrawPixel(m_Position.X - 7, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X + 7, m_Position.Y + 1, color);
                    context.DrawPixel(m_Position.X - 7, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X + 7, m_Position.Y + 2, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y + 3, color);
                    context.DrawPixel(m_Position.X - 6, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X + 6, m_Position.Y + 4, color);
                    context.DrawPixel(m_Position.X - 5, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X + 5, m_Position.Y + 5, color);
                    context.DrawPixel(m_Position.X - 4, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X - 3, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X + 3, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X + 4, m_Position.Y + 6, color);
                    context.DrawPixel(m_Position.X - 2, m_Position.Y + 7, color);
                    context.DrawPixel(m_Position.X - 1, m_Position.Y + 7, color);
                    context.DrawPixel(m_Position.X, m_Position.Y + 7, color);
                    context.DrawPixel(m_Position.X + 1, m_Position.Y + 7, color);
                    context.DrawPixel(m_Position.X + 2, m_Position.Y + 7, color);
                }
            }
            else
            {
                m_Sheet[m_State].ForEach(p => context.DrawPixel(m_Position.X + p.X - 8, m_Position.Y + p.Y - 8, color));
            }
        }
    }
}
